/*

  Broadcom BCM430x wireless driver

  Copyright (c) 2005 Martin Langer <martin-langer@gmx.de>,
                     Stefano Brivio <st3@riseup.net>
                     Michael Buesch <mbuesch@freenet.de>
                     Danny van Dyk <kugelfang@gentoo.org>
                     Andreas Jaggi <andreas.jaggi@waterwave.ch>

  Some parts of the code in this file are derived from the ipw2200
  driver  Copyright(c) 2003 - 2004 Intel Corporation.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; see the file COPYING.  If not, write to
  the Free Software Foundation, Inc., 51 Franklin Steet, Fifth Floor,
  Boston, MA 02110-1301, USA.

*/

#include <linux/types.h>


struct bcm430x_private;

u16 bcm430x_phy_read(struct bcm430x_private *bcm, u16 offset);
void bcm430x_phy_write(struct bcm430x_private *bcm, int offset, u16 val);

int bcm430x_phy_init(struct bcm430x_private *bcm);

void bcm430x_phy_set_antenna_diversity(struct bcm430x_private *bcm);
void bcm430x_phy_calibrate(struct bcm430x_private *bcm);
int bcm430x_phy_connect(struct bcm430x_private *bcm, int connect);

void bcm430x_phy_lo_b_measure(struct bcm430x_private *bcm);
void bcm430x_phy_lo_g_measure(struct bcm430x_private *bcm);
void bcm430x_phy_xmitpower(struct bcm430x_private *bcm);

void bcm430x_phy_lo_adjust(struct bcm430x_private *bcm);
